#include <stdio.h>
#include <stdlib.h>

#include "../generic/poMemory.h"

#define TO_MB(val) ((val) / 1024.0 / 1024.0)

int main ( int argc, char *argv[])
{
    long i, j, numRuns = 20;
    double usedStart = TO_MB(poMemGetUsed());
    double physStart = TO_MB(poMemGetPhysical());
    double usedLast = usedStart;
    double usedCurrent;

    printf ("Start : Used: %6.2f MB Physical: %.2f MB\n", usedStart, physStart);

    for (i=1; i <= numRuns; i++) {
        char *new = malloc (i * 1024 * 1024);
        for (j=0; j < i * 1024 *1024; j++) {
            new[j] = (char)j;
        }

        usedCurrent = TO_MB (poMemGetUsed());
        printf ("Run %2ld: Used: %6.2f MB Diff: %6.2f\n",
          i, usedCurrent, (usedCurrent - usedLast));
        usedLast = usedCurrent;
        free (new);
    }
    return 0;
}
