#include <tcl.h>

#include "poMemory.h"

static int poTclMemGetUsed (void * clientData, Tcl_Interp *interp, int argc, const char *argv[])
{
    Tcl_SetObjResult( interp, Tcl_NewDoubleObj( poMemGetUsed() / 1024.0 / 1024.0 ) ); 
    return TCL_OK;
}

static int poTclMemGetPhysical (void * clientData, Tcl_Interp *interp, int argc, const char *argv[])
{
    Tcl_SetObjResult( interp, Tcl_NewDoubleObj( poMemGetPhysical() / 1024.0 / 1024.0 ) ); 
    return TCL_OK;
}

int poMemInitTclLib (Tcl_Interp *interp)
{
    Tcl_CreateCommand (interp, "poMemory::used", (Tcl_CmdProc *)poTclMemGetUsed, 
                       (ClientData) NULL, (Tcl_CmdDeleteProc *) NULL);
    Tcl_CreateCommand (interp, "poMemory::physical", (Tcl_CmdProc *)poTclMemGetPhysical, 
                       (ClientData) NULL, (Tcl_CmdDeleteProc *) NULL);
    return TCL_OK;
}

EXTERN int Pomemory_Init (Tcl_Interp *interp)
{
    if (Tcl_InitStubs (interp, "8.6-", 0) == NULL) {
        return TCL_ERROR;
    }

    if (poMemInitTclLib (interp) == TCL_ERROR) {
        return TCL_ERROR;
    }

    return Tcl_PkgProvide (interp, PACKAGE_NAME, PACKAGE_VERSION);
}
