#include <stdio.h>
#include <stdint.h>

#include <mach/mach_init.h>
#include <mach/task.h>
#include <sys/types.h>
#include <sys/sysctl.h>

size_t poMemGetUsed()
{
    size_t size = 0;

    struct task_basic_info t_info;
    mach_msg_type_number_t t_info_count = TASK_BASIC_INFO_COUNT;

    if (KERN_SUCCESS != task_info(mach_task_self(),
        TASK_BASIC_INFO, (task_info_t)&t_info, &t_info_count)) {
        return 0;
    }
    size = t_info.resident_size;
    return size;
}

size_t poMemGetPhysical()
{
    size_t size = 0;

    int mib[2] = { CTL_HW, HW_MEMSIZE };
    u_int namelen = sizeof(mib) / sizeof(mib[0]);
    uint64_t totalsize;
    size_t len = sizeof(totalsize);

    if (sysctl(mib, namelen, &totalsize, &len, NULL, 0) < 0) {
        return 0;
    }
    size = totalsize;
    return size;
}
