package require poMemory

set usedStart [poMemory::used]
set physStart [poMemory::physical]
puts [format "Start : Used: %6.2f MB  Physical: %.2f MB" $usedStart $physStart]
if { $physStart == 0.0 } {
    puts "Error: Could not retrieve physical memory"
}
puts "Creating strings increasing by 1 MB ..."

set numRuns 20
set str "1"
set usedLast $usedStart
for { set i 1 } { $i <= $numRuns } { incr i } {
    set new [string repeat $str [expr {$i * 1024 * 1024}]]]
    set usedCurrent [poMemory::used]
    puts [format "Run %2d: Used: %6.2f MB Diff: %6.2f" \
          $i $usedCurrent [expr {$usedCurrent - $usedLast }]]
    set usedLast $usedCurrent
}

if { [expr { int ([poMemory::used] - $usedStart) }] != $numRuns } {
    puts "Warning: Used memory changed too much"
}

puts "Using Tcl [info patchlevel], poMemory [package version poMemory]"
