#include <stdio.h>
#include <stdint.h>
#include <unistd.h>

size_t poMemGetUsed()
{
    size_t size = 0;

    /* See https://man7.org/linux/man-pages/man5/proc.5.html */
    FILE *fp;
    long pageSize;
    unsigned long virtSize;
    long residentSize;

    if (!(fp = fopen ("/proc/self/statm", "r"))) {
        return 0;
    }
    if (2 != fscanf (fp, "%lu %ld", &virtSize, &residentSize) ) {
        return 0;
    }
    fclose (fp);

    /* Size is returned in pages. Convert to bytes. */
    pageSize = sysconf(_SC_PAGESIZE);
    size = residentSize * pageSize;
    return size;
}

size_t poMemGetPhysical()
{
    size_t size = 0;

    long pages    = sysconf(_SC_PHYS_PAGES);
    long pageSize = sysconf(_SC_PAGE_SIZE);
    size = pages * pageSize;

    return size;
}
